netpipe(1)

NAME
NetPIPE - network protocol independent performance evaluator

SYNOPSIS
NPtcp [-A buffer_alignment ] [-a ] [-b TCP_buffer_size ] [-h host_name ] [-H server_name ] [-i increment ] [-l starting_msg_size ] [-O buffer_offset ] [-o output_filename ] [-P ] [-p port ] [-r ] [-s ] [-t ] [-u ending_msg_size ]

NPmpi [-A buffer_alignment ] [-a ] [-i increment ] [-l starting_msg_size ] [-O buffer_offset ] [-o output_filename ] [-P ] [-s ] [-u ending_msg_size ]

NPpvm [-A buffer_alignment ] [-a ] [-i increment ] [-l starting_msg_size ] [-O buffer_offset ] [-o output_filename ] [-P ] [-r ] [-s ] [-t ] [-u ending_msg_size ]

DESCRIPTION

NetPIPE is a protocol independent performance tool that encapsulates the best of ttcp and netperf and visually represents the network performance under a variety of conditions. By taking the end-to-end application view of a network, NetPIPE clearly shows the overhead associated with different protocol layers. NetPIPE answers such questions as:
    How soon will a given data block of size k arrive at its destination?

    Which network and protocol will transmit size k blocks the fastest?

    What is a given network's effective maximum throughput and saturation level?

    Does there exist a block size k for which the throughput is maximized?

    How much communication overhead is due to the network communication protocol layer(s)?

    How quickly will a small (< 1 kbyte) control message arrive, and which network and protocol are best for this purpose?

NetPIPE is provided with interfaces for TCP, MPI, and PVM, but TCP is the most commonly used interface for general network testing purposes. It should be easy to write new interfaces for other reliable protocols based on the examples provided by the TCP, MPI and PVM interfaces.

TESTING TCP

Typical use for TCP involves running the TCP NetPIPE receiver on one system with the command

NPtcp -r

NPtcp -r -H <specified interface address/hostname>

and running the TCP NetPIPE transmitter on another system with the command

NPtcp -h receiver_hostname -o output_filename -P -t

If any options are used that modify the test protocol, including -i, -l, -p, -s, and -u, those parameters must be used on both the transmitter and the receiver, or the test will not run properly.

TESTING PVM

Typical use for PVM first requires starting PVM with the command

pvm

and adding a second machine with the PVM command

add othermachine

(then exit the PVM command line interface). Then run the PVM NetPIPE receiver on one system with the command

NPpvm -r

and run the TCP NetPIPE transmitter on the other system with the command

NPpvm -t -o output_filename -P

If any options are used that modify the test protocol, including -i, -l, -p, -s, and -u, those parameters must be used on both the transmitter and the receiver, or the test will not run properly.

TESTING MPI

Use of the MPI interface for NetPIPE depends on the MPI implementation used. For the Argonne MPICH implementation using the p4 device (for a cluster of individual systems interconnected using TCP/IP), create a file that contains the hostnames of the two systems you want to include in the test, with one hostname on each line of the file (assume the file is named "machines.p4"). Then, use the command

mpirun -machinefile machines.p4 -np 2 NPmpi -o output_filename -P

to start the test. MPICH will start an NPmpi process on each of the two selected machines and the test will begin.

TESTING METHODOLOGY

NetPIPE tests network performance by sending a number of messages at each block size, starting from the lower bound on message size. NetPIPE increments the message size until the upper bound on message size is reached or the time to transmit a block exceeds one second, which ever occurs first.

NetPIPE 's output file may be graphed with a program such as gnuplot(1) to view the results of the test. NetPIPE 's output file contains five columns: time to transfer the block, bits per second, bits in block, bytes in block, and variance. These columns may be graphed to represent and compare the network's performance. For example, the network signature graph can be created by graphing time versus bits per second. Sample gnuplot(1) commands for such a graph would be

set logscale x

plot "NetPIPE.out" using 1:2

The more traditional throughput versus block size graph can be created by graphing bytes versus bits per second. Sample gnuplot(1) commands for such a graph would be

set logscale x

plot "NetPIPE.out" using 4:2

OPTIONS

-A  alignment
    Align buffers to the given boundary. For example, a value of 4 would align buffers to 4-byte (word) boundaries.

-a  Specify asynchronous receive (a.k.a. preposted receive), if the underlying protocol supports it.

-b buffer_size
    [TCP only] Set send and receive TCP buffer sizes.

-h hostname
    [TCP transmitter only] Specify name of host to which to connect.

-i increment
    Specify increment step size (default is an exponentially increasing increment).

-l start_msg_size
    Specify the starting message size. The test will start with messages of this size and increment, either exponentially or with an increment specified by the -i flag, until a block requires more than one second to transmit or the ending message size specified by the -u flag is reached, which ever occurs first.

-O buffer_offset
    Specify offset of buffers from alignment. For example, specifying an alignment of 4 (with -A) and an offset of 1 would align buffers to the first byte after a word boundary.

-o output_filename
    Specify output filename. By default, the output filename is NetPIPE.out.

-P  Print results on screen during execution of the test. By default, NetPIPE is silent during execution of the test.

-p port_number
    [TCP only] Specify TCP port number to which to connect (for the transmitter) or the port on which to listen for connections (for the receiver).

-r  [TCP only] This process is a TCP receiver.

-s  Set streaming mode: data is only transmitted in one direction. By default, the transmitter measures the time taken as each data block is sent from the transmitter to the receiver and back, then divides the round-trip time by two to obtain the time taken by the message to travel in each direction. In streaming mode, the receiver measures the time required to receive the message and sends the measured time back to the transmitter for posting to the output file.

-t  [TCP only] This process is a TCP transmitter.

-u ending_msg_size
    Specify the ending message size. By default, the test will end when the time to transmit a block exceeds one second. If -u is specified, the test will end when either the test time exceeds one second or the ending message size is reached, which ever occurs first.

FILES

NetPIPE.out
    Default output file for NetPIPE. Overridden by the -o option.

AUTHOR

Quinn Snell <snell@cs.byu.edu>, Guy Helmer <ghelmer@scl.ameslab.gov>, and others.

Clark Dorman <dorman@s3i.com> contributed the PVM interface.

Information about NetPIPE can be found on the World Wide Web at http://www.scl.ameslab.gov/netpipe/.

BUGS
By nature, NetPIPE will use as much of the network bandwidth as possible. Other users of the network may notice the effect.